// SPDX-License-Identifier: MIT
// SPDX-FileCopyrightText: 2022 Ivan Baidakou

#include "board.h"

namespace rl = rotor_light;

namespace message {
struct Ping : rl::Message {
  using Message::Message;
  static constexpr auto type_id = __LINE__;
};

struct Pong : rl::Message {
  using Message::Message;
  static constexpr auto type_id = __LINE__;
};
} // namespace message

struct Pinger : rl::Actor<2> {
  using Parent = Actor<2>;

  void initialize() override {
    subscribe(&Pinger::on_pong);
    Parent::initialize();
  }

  void advance_start() override {
    Parent::advance_start();
    ping();
  }

  void ping() {
    Board::toggle_led();
    send<rl::ctx::thread, message::Ping>(0, ponger_id);
  }

  void on_pong(message::Pong &) {
    add_event<rl::ctx::thread>(
        500, [](void *data) { static_cast<Pinger *>(data)->ping(); }, this);
  }

  rl::ActorId ponger_id;
};

struct Ponger : rl::Actor<2> {
  using Parent = Actor<2>;

  void initialize() override {
    subscribe(&Ponger::on_ping);
    Parent::initialize();
  }
  void on_ping(message::Ping &) {
    send<rl::ctx::thread, message::Pong>(0, pinger_id);
  }
  rl::ActorId pinger_id;
};

using Supervisor =
    rl::Supervisor<rl::SupervisorBase::min_handlers_amount, Pinger, Ponger>;
using Storage = rl::traits::MessageStorage<rl::message::ChangeState,
                                           rl::message::ChangeStateAck,
                                           message::Ping, message::Pong>;
using Queue = rl::Queue<Storage, 5>; /* upto 5 messages in 1 queue */
using Planner = rl::Planner<1>;      /* upto 1 time event */

Supervisor sup;

int main(int, char **) {
  Board::init_start();
  Board::enable_timer();
  ROTOR_LIGHT_ENABLE_INTERRUPTS();

  /* setup */
  Queue queue;
  Planner planner;
  rl::Context context{&queue, &planner, &Board::get_now};
  sup.bind(context);

  auto pinger = sup.get_child<0>();
  auto ponger = sup.get_child<1>();
  pinger->ponger_id = ponger->get_id();
  ponger->pinger_id = pinger->get_id();
  /* let it polls timer */
  sup.start(true);

  /* main cycle */
  sup.process();
  return 0;
}
